function D=average weighted(A,B,C1,C2,P,Q) 
%P and Q represent the weights.
%Matrix A and B are average fused according to the weight.

L=size(A);

for i=1:L(1)
  for j=1:L(2)
    A1(1,:)=0;
    A1(:,1)=0;
    A1(L(1)+2,:)=0;
    A1(:,L(2)+2)=0;
    A1(i+1,j+1)=A(i,j);
  end
end 
for i=1:L(1)
  for j=1:L(2)
    B1(1,:)=0;
    B1(:,1)=0;
    B1(L(1)+2,:)=0;
    B1(:,L(2)+2)=0;
    B1(i+1,j+1)=B(i,j);
  end
end
%Weight average fusion.
for i=2:1:(L(1)+1)
  for j=2:1:(L(2)+1)
    if C1(i-1,j-1)==1| C2(i-1,j-1)==1
     VA1=var([A1(i-1,j-1)  A1(i-1,j)  A1(i-1,j+1)   A1(i,j-1)  A1(i,j)  A1(i,j+1)  A1(i+1,j-1)  A1(i+1,j)  A1(i+1,j+1)]);
      VB1=var([B1(i-1,j-1)  B1(i-1,j)  B1(i-1,j+1)   B1(i,j-1)  B1(i,j)  B1(i,j+1)  B1(i+1,j-1)  B1(i+1,j)  B1(i+1,j+1)]);
      M=max([VA1  VB1]);
        if  VA1>=M   
        XH3(i-1,j-1)=P*A1(i,j);
        else
        XH3(i-1,j-1)=Q*B1(i,j);
        end
      else
      a1=abs(A1(i,j));
      b1=abs(B1(i,j));
      M=max([a1 b1]);
        if a1>=M
        XH3(i-1,j-1)=P*A1(i,j);
        else
        XH3(i-1,j-1)=Q*B1(i,j);
        end
      end
  end
end
D=XH3/(P+Q);